Bug 426752 - Review Request: ghc-X11-xft - Haskell binding to Xft
Review Request: ghc-X11-xft - Haskell binding to Xft
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
low Severity medium
: ---
: ---
Assigned To: Yaakov Nemoy
Fedora Extras Quality Assurance
http://hackage.haskell.org/cgi-bin/ha...
:
Depends On:
Blocks: 426754 xmobar
  Show dependency treegraph
 
Reported: 2007-12-25 15:16 EST by Yaakov Nemoy
Modified: 2010-11-12 10:35 EST (History)
9 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-09-12 10:27:44 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
loupgaroublond: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)
ghc-X11-xft.spec-1.patch (1.25 KB, patch)
2009-06-20 19:24 EDT, Jens Petersen
no flags Details | Diff
deps clean up (2.40 KB, patch)
2009-08-25 23:59 EDT, Jens Petersen
no flags Details | Diff

  None (edit)
Description Yaakov Nemoy 2007-12-25 15:16:52 EST
Spec URL: http://fedorapeople.org/~ynemoy/xmonad/x11-xft.spec
SRPM URL: http://fedorapeople.org/~ynemoy/xmonad/ghc681-x11-xft-0.2-1.fc8.src.rpm
Description: 
Haskell bindings to the Xft, X Free Type interface library, and some Xrender parts

This package is for xmonad-contrib, which is to follow.
Comment 1 Jens Petersen 2008-02-12 22:07:36 EST
The name should be ghc-X11-xft IMHO, following the upstream naming.
Comment 2 Jens Petersen 2008-08-22 04:13:28 EDT
Can you add a URL field and a url for the source?
Comment 3 Jens Petersen 2008-11-30 19:05:50 EST
Yaakov, do you still have a copy of your .spec file?  (Above links are broken.)
Comment 4 Till Maas 2008-12-10 06:12:22 EST
The links to the spec/SRPM are not working, therefore nothing can be done here.
Comment 5 Jason Tibbitts 2008-12-21 15:52:17 EST
Please clear the whiteboard when this is ready for review.
Comment 6 Jens Petersen 2009-04-25 18:54:34 EDT
ping?
Comment 8 Jens Petersen 2009-06-03 02:11:49 EDT
Please update to latest cabal2spec, thanks
Comment 10 Jens Petersen 2009-06-13 04:00:42 EDT
Can you update your package again based on your experience
of the utf8-string review?
Comment 12 Jens Petersen 2009-06-20 09:08:56 EDT
cabal2spec-diff looks ok to me - though you should keep periods in the descriptions, which should be made of sentences.
Comment 13 Jens Petersen 2009-06-20 19:19:40 EDT
Zach, you need to include the dependency on libXft explicitly by adding

 BuildRequires: libXft-devel

to the base (src) package and

 Requires: libXft-devel

to the devel subpackage.
Unfortunately cabal2spec is not smart enough to do that yet.
That should allow the package to build in mock
and avoid linking errors etc with the devel package.
Comment 14 Jens Petersen 2009-06-20 19:24:27 EDT
Created attachment 348767 [details]
ghc-X11-xft.spec-1.patch

Perhaps I confused you about fullstops in the previous review.

Just to clarify, the rule of thumb is no fullstops (periods) in the summary
field but fullstops in the description fields: you can follow the example
of cabal2spec there. :)
Comment 16 Jason Tibbitts 2009-07-01 19:35:48 EDT
Who is reviewing this and who is submitting it?  I see Zach signed up to review it, but he's the one producing packages, which is a bit backwards.  Nobody's going to sign up to review this since it's already assigned to Zach, yet the fedora-revlew is not set.
Comment 17 Yaakov Nemoy 2009-07-03 07:52:08 EDT
Let me take this one over then.

Apparently it won't build without the UTF-8 package, which i'm going to take over as a review too.
Comment 18 Yaakov Nemoy 2009-07-03 08:17:28 EDT
The package needs to BR ghc-utf8-string too.
Comment 19 Yaakov Nemoy 2009-07-03 08:20:10 EDT
And not paying attention, i forgot to mention it also needs to BR ghc-X11 itself.
Comment 21 Yaakov Nemoy 2009-07-15 08:17:20 EDT
Building X11-xft-0.2...
[1 of 2] Compiling Graphics.X11.Xrender ( dist/build/Graphics/X11/Xrender.hs, dist/build/Graphics/X11/Xrender.o )
[2 of 2] Compiling Graphics.X11.Xft ( dist/build/Graphics/X11/Xft.hs, dist/build/Graphics/X11/Xft.o )
Graphics/X11/Xft.hsc:57:7:
    Could not find module `Codec.Binary.UTF8.String':
      Perhaps you haven't installed the profiling libraries for package `utf8-string-0.3.5'?
      Use -v to see a list of the files searched for.


This is a dependency issue that i'm also bringing up with Jens
Comment 22 Yaakov Nemoy 2009-07-15 08:17:44 EDT
Oh, and it seems there's a new upstream, so could you please rebase against that?
Comment 23 Jens Petersen 2009-07-16 04:17:39 EDT
(In reply to comment #21)
> This is a dependency issue that i'm also bringing up with Jens  

Well it would be better if cabal2spec was smart enough to
do all the right BuildRequires for dependencies, that would
avoid these: so best to test in mock before submitting
in the meantime.
Comment 24 Yaakov Nemoy 2009-07-16 04:22:43 EDT
What follows is some IRC chatter over two ways of doing it. Let's go with the
latter. Please explicitely BR the -prof and -doc packages where you have
ghc-*-devel BR'd.

(01.58.36) ( juhp) loupgaroublond: hmm
(01.59.36) ( juhp) sounds "complicated" :)
(02.00.09) ( juhp) if you're going to make -devel require -prof and -doc then
might as well not subpackage ;)
(02.00.49) ( juhp) we also do it for BuildRequires where it counts
(02.01.20) ( juhp) probably we should just drop the switches?
(03.00.20) :: ritek (n=eduardo@201.171.111.160) has quit ("������")
(09.54.24) ( loupgaroublond) nah, just the issue is to make sure packages build
properly, either that or we have to explicitly require all the appropriate 'non
devel' packages in a 'devel' situation
(09.56.50) ( juhp) yeah in fact most of the subpackaging is pain
(09.57.10) ( juhp) I am still tempted to unsubpackage doc
(09.57.42) ( juhp) loupgaroublond: but i don't get it: if -devel requires -prof
and -doc then how does subpackaging help you?
(10.00.57) ( loupgaroublond) because -devel is only supposed to contain the
bits in the shared libs necessary to compile other packages
(10.01.03) ( loupgaroublond) the ghc-foo contains the shared libs
(10.01.14) ( loupgaroublond) the *-doc has the haddock stuff, and the -prof has
the profiling extras
(10.01.55) ( loupgaroublond) but if you install the -devel package, we're
assuming you need all those other bits too
(10.04.57) ( juhp) why?
(10.05.10) ( juhp) so then we don't need subpackages
(10.05.21) ( juhp) everything should just be in -devel
(10.07.35) ( loupgaroublond) because sometimes you don't want devel?
(10.07.57) ( loupgaroublond) or i'll just tell jochem to include the -prof and
-doc dependencies
(10.08.20) ( loupgaroublond) anyways, it's a thought
(10.08.25) ( loupgaroublond) there's more than one way to skin a cat though
(10.11.40) ( juhp) maybe I am missing some context
Comment 25 Jens Petersen 2009-08-20 21:40:37 EDT
Zach, are you going to update the package?
Comment 26 Zach Oglesby 2009-08-24 09:57:24 EDT
Indeed, sorry we just had a baby and I see to not have enough time in the day, I will try and get it updated today or tomorrow.
Comment 28 Yaakov Nemoy 2009-08-25 10:43:37 EDT
MUST: rpmlint must be run on every package. The output should be posted in the review.[1]
[yankee@koan ghc-X11-xft]$ rpmlint -iv *{spec,rpm}
ghc-X11-xft.src: I: checking                      
ghc-X11-xft.src: I: checking                      
ghc-X11-xft-devel.i586: I: checking               
ghc-X11-xft-devel.ppc: I: checking                
ghc-X11-xft-devel.x86_64: I: checking             
ghc-X11-xft-doc.i586: I: checking                 
ghc-X11-xft-doc.i586: E: description-line-too-long This package contains development documentation files for the ghc-X11-xft library.                                                                                         
Your description lines must not exceed 79 characters. If a line is exceeding                                   
this number, cut it to fit in two lines.                                                                       

ghc-X11-xft-doc.ppc: I: checking
ghc-X11-xft-doc.ppc: E: description-line-too-long This package contains development documentation files for the ghc-X11-xft library.                                                                                          
Your description lines must not exceed 79 characters. If a line is exceeding                                   
this number, cut it to fit in two lines.                                                                       

ghc-X11-xft-doc.x86_64: I: checking
ghc-X11-xft-doc.x86_64: E: description-line-too-long This package contains development documentation files for the ghc-X11-xft library.                                                                                       
Your description lines must not exceed 79 characters. If a line is exceeding                                   
this number, cut it to fit in two lines.                                                                       

ghc-X11-xft-prof.i586: I: checking
ghc-X11-xft-prof.i586: E: devel-dependency ghc-X11-xft-devel
Your package has a dependency on a devel package but it's not a devel package
itself.                                                                      

ghc-X11-xft-prof.i586: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.                                                         

ghc-X11-xft-prof.i586: W: devel-file-in-non-devel-package /usr/lib/ghc-6.10.3/X11-xft-0.3/libHSX11-xft-0.3_p.a
A development file (usually source code) is located in a non-devel package. If                                
you want to include source code in your package, be sure to create a                                          
development package.                                                                                          

ghc-X11-xft-prof.ppc: I: checking
ghc-X11-xft-prof.ppc: E: devel-dependency ghc-X11-xft-devel
Your package has a dependency on a devel package but it's not a devel package
itself.

ghc-X11-xft-prof.ppc: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

ghc-X11-xft-prof.ppc: W: devel-file-in-non-devel-package /usr/lib/ghc-6.10.3/X11-xft-0.3/libHSX11-xft-0.3_p.a
A development file (usually source code) is located in a non-devel package. If
you want to include source code in your package, be sure to create a
development package.

ghc-X11-xft-prof.x86_64: I: checking
ghc-X11-xft-prof.x86_64: E: devel-dependency ghc-X11-xft-devel
Your package has a dependency on a devel package but it's not a devel package
itself.

ghc-X11-xft-prof.x86_64: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

ghc-X11-xft-prof.x86_64: W: devel-file-in-non-devel-package /usr/lib64/ghc-6.10.3/X11-xft-0.3/libHSX11-xft-0.3_p.a
A development file (usually source code) is located in a non-devel package. If
you want to include source code in your package, be sure to create a
development package.

11 packages and 1 specfiles checked; 6 errors, 6 warnings.

>>> CHECK --> All normal for GHC packages with one exception. I think cabal2spec is generating the description errors because i had the same problem on another review.
n
MUST: The package must be named according to the Package Naming Guidelines .
>>> CHECK

MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. [2] .
>>> CHECK

MUST: The package must meet the Packaging Guidelines .
>>> CHECK

MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
>>> CHECK

MUST: The License field in the package spec file must match the actual license. [3]
>>> CHECK

MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.[4]
>>> CHECK

MUST: The spec file must be written in American English. [5]
>>> CHECK

MUST: The spec file for the package MUST be legible. [6]
>>> CHECK

MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
>>> CHECK

MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. [7]
>>> CHECK

MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. [8]
>>> CHECK

MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
>>> CHECK

MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. [12]
>>> CHECK

MUST: A Fedora package must not list a file more than once in the spec file's %files listings. [13]
>>> CHECK

MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. [14]
>>> CHECK

MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT). [15]
>>> CHECK

MUST: Each package must consistently use macros. [16]
>>> CHECK

MUST: The package must contain code, or permissable content. [17]
>>> CHECK

MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). [18]
>>> CHECK

MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. [18]
>>> CHECK

MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} [22]
>>> MISSING

MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. [24]
>>> CHECK

MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT). [25]
>>> CHECK

MUST: All filenames in rpm packages must be valid UTF-8. [26]
>>> CHECK

SHOULD Items:
Items marked as SHOULD are things that the package (or reviewer) SHOULD do, but is not required to do.

SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. [27]
>>> CHECK

SHOULD: The reviewer should test that the package builds in mock. [29]
>>> CHECK

SHOULD: The package should compile and build into binary rpms on all supported architectures. [30]
>>> CHECK

SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
>>> CHECK

SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency. [22]
>>> MISSING

Resolution: Not yet passed. Please add in the last depedencies and fix the description.

Congrats on the baby :)
Comment 29 Yaakov Nemoy 2009-08-25 11:22:41 EDT
Actually, i take that back. Just fix the description. I was looking over the template again, and i forgot that we put everything in a -devel package. Just fix the description and it's a pass. I was looking at it funny.
Comment 31 Jens Petersen 2009-08-25 23:59:04 EDT
Created attachment 358664 [details]
deps clean up

Please apply these dependency fixes.

I know it is a bit tedious doing all this stuff by hand,
but let's try to keep our sig packages clean until
cabal2spec is smart enough. :)

http://koji.fedoraproject.org/koji/taskinfo?taskID=1634073
Comment 32 Kevin Fenzi 2009-08-26 18:32:30 EDT
Please add a cvs template here so we know what you want. 
http://fedoraproject.org/wiki/PackageMaintainers/CVSAdminProcedure
Comment 33 Zach Oglesby 2009-08-27 04:35:58 EDT
Sorry about that!

New Package CVS Request
=======================
Package Name: ghc-X11-xft
Short Description: Haskell binding to Xft
Owners: zoglesby
Branches: F10 F11
InitialCC: haskell-sig
Comment 34 Jason Tibbitts 2009-08-28 10:31:09 EDT
Franches are named "F-10", "F-11", etc.  I've fixed that up.

CVS done.
Comment 36 Jens Petersen 2010-11-10 02:36:15 EST
Package Change Request
======================
Package Name: ghc-X11-xft
New Branches: el6
Owners: zoglesby mathstuf petersen
InitialCC: haskell-sig
Comment 37 Jason Tibbitts 2010-11-11 10:50:00 EST
Could we get an ack from zoglesby and mathstuf?
Comment 38 Ben Boeckel 2010-11-11 11:03:26 EST
ack
Comment 39 Kevin Fenzi 2010-11-12 10:35:38 EST
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.